/* 9/11/09 jupbstr2.txt is jupsbstr.txt rewritten to bootstrap by individual. */

/* 9/5/08 jupsbstr.txt is jumpups.txt but rewritten to bootstrap mean differences between declines
and recoveries, in order to have a bootstrap test of H0: their difference is 0. */
/* -- 9/18/08 adding bootstraps on the declines in the first place. */

/* 4/3/08 jumpups2.txt is just me re-running the jump-ups to think about medians. */

/* 6/1/07 Jumpups.txt draws file names etc. from gls4.txt. It will generate distributional
information on the differences between accepted offers in an environment and the
subsequent first offers in new spells i nhte same environment. */

closeall;
library pgraph;
graphset;
format /off;

/*
@================================ Wait, Cost ======================================================================@
@================================ Recoveries (jump ups) ===========================================================@
load rdata[1096,17] = c:\Schotter\waitcost.txt;
rdata = zeros(1,17) | rdata;

@ All jumps together @
jumps = zeros(1,2); jupdate = zeros(1,2);
i = 2;
j = 0;
do until i > rows(rdata);
  if (rdata[i,10] <= 1) AND (rdata[i,3] .eq rdata[i-1,3]);			@ if offer # is 1 and environment # for this trial = env # for previous trial @
    if j<=0;
      jumps[1,1] = rdata[i,13] - rdata[i-1,13];
      jumps[1,2] = rdata[i,1];							@ adding an ID @
      j = j + 1;
      else;
      jupdate = (rdata[i,13] - rdata[i-1,13]) ~ rdata[i,1];
      jumps = jumps | jupdate;
    endif;
    else; ;
  endif;
  i = i + 1;
endo;

@ Start new bootstrap code, also get medians and sample sizes @
n = rows(jumps);




@================================= Declines (first-last) ========================================================@
@ Wait, Cost @
load rdata[1096,17] = c:\Schotter\waitcost.txt;

@ 6/6/07 First calculate the mean etc. of the first to last decline *including* the zeros/people whose first res w worked @
Firstlast_wc = zeros(570,2);
FLindex_wc = zeros(570,2);
FLenvtrl = zeros(570,2);	@ hold env & trial nos @


i = 1; j = 0;
do until i > 1095;
  if rdata[i,10] <= 1;		@ so it's a first offer in the trial @
    j = j + 1;			@ j keeps track of # of environment/trials using each time the offer # hits 1 @
    Firstlast_wc[j,1] = rdata[i,13];	@ Wres for 1st offer in trial @
    FLindex_wc[j,1] = rdata[i,1];	@ ID # @
    FLenvtrl[j,1:2] = rdata[i,3:4];		@ environment # ~ trial # @
    else;
  endif;
  if rdata[i+1,10] <= 1;			@ so this is the last offer, may also be the first @
    Firstlast_wc[j,2] = rdata[i,13];
    FLindex_wc[j,2] = rdata[i,1];
    else; ;
  endif;
  i = i + 1;
endo;

Firstlast_wc[570,2] = rdata[1096,13];
FLindex_wc[570,2] = rdata[1096,1];
FLenvtrl[570,1:2] = 3 ~ 5;



@print "Firstlast_wc"; print firstlast_wc; print "FLindex_wc"; print flindex_wc;@
FL = Firstlast_wc ~ FLindex_wc ~ FLenvtrl;
FL = delif(FL, FL[.,6] .<= 1);				@ applying same sample selection criteria as for recoveries, no first trials since they have no recoveries @
FL_wc = FL;

FLD_wc = FL_wc[.,1] - FL_wc[.,2];			@ 6/6/07 It should be FL_wc[.,1] - FL_wc[.,2], not sure what went wrong here, was 3. @

@print "# of trials of 570 in Wait, Cost in which at least 2 offers"; print (rows(FL_wc));@


@============================== Bootstrap ON INDIVIDUALS ====================================================================@
n = 38;		@ # subjects, was # of observations in base sample @
k = 1000;				@ # of bootstrap iterations, start small @
z = rows(jumps); print "Z"; print z;	@ # of recoveries, should always = 38*12, should be 456 as is # declines here @
jbootID = zeros( k,n );
dbootID = zeros( k,n );
jbootspl = 0;
dbootspl = 0;
draw1 = zeros(n,1);
bootvec = zeros(z,1);
bootmean = zeros(k,1);

boot = 1;
do until boot > k;
  draw1 = rndu(n,1) * (n-1);
  jbootID[boot,.] = (round( draw1 ) + 1)';
  boot = boot + 1;
endo;

boot = 1;
do until boot > k;
  draw1 = rndu(n,1) * (n-1);
  dbootID[boot,.] = (round( draw1 ) + 1)';
  boot = boot + 1;
endo;

@ Use bootstrap ID matrix to put recovery "jumps" entries for bootstrap draws into each entry of jbootspl matrix @
r = 1;	@rows@ c = 1; ID = 0; dbsno=0; jbsno=0; minjd=0; @holds # rows of bootstrapped sample, should always come out same here@
do until r > k;
  jbootspl = 0; dbootspl = 0;
  c = 1;	@ cols @
  do until c > n;
    ID = jbootID[r,c];
    @ now deal with drawing all individual entries @
    j = 1;
    do until j > z;
      if jumps[j,2] .eq ID;
        jbootspl = jbootspl | jumps[j,1];
        else; ;
      endif;
      j = j + 1;
    endo;
    c = c + 1;
  endo;
  c = 1;	@ cols @
  do until c > n;
    ID = dbootID[r,c];
    @ now deal with drawing all individual entries @
    j = 1;
    do until j > z;
      if FL_wc[j,3] .eq ID;
        dbootspl = dbootspl | FLD_wc[j,1];
        else; ;
      endif;
      j = j + 1;
    endo;
    c = c + 1;
  endo;
  jbsno = rows(jbootspl);
  dbsno = rows(dbootspl);
  minjd = minc( jbsno | dbsno );
  jbootspl = jbootspl[1:minjd,1];
  dbootspl = dbootspl[1:minjd,1];
  bootvec = dbootspl - jbootspl;
  bootmean[r,1] = meanc(bootvec);
  r = r + 1;
endo;

print "WC jumps rows"; print rows(jumps); print "FLD_wc rows"; print rows(FLD_wc);

@ Note first-last's and jumps should have the same # of entries. Code as if do and watch for errors.@

@ Make 95% CI on mean difference by sorting and cutting the mean vector @
@bootmean = bootmean';@  @so kx1@
bootmean = sortc(bootmean,1);
upCI = .975*k;
upCI = floor(upCI);
loCI = .025*k;
loCI = floor(loCI);
upperCI = bootmean[upCI];
lowerCI = bootmean[loCI];

output file = c:\schotter\aer\jupbstr2.out;
Print "Bootstrapped 95% CI on Wait, Cost Decline - Recovery Mean, resampling individuals"; print (lowerCI ~ upperCI);
output off;

@============================== End Bootstrap ====================================================================@
*/


@=====================================================================================================================@
@================================ No Wait, Cost ======================================================================@
@ No wait, cost @
load rdata[1517,17] = c:\schotter\nowaitco.txt;
rdata = zeros(1,17) | rdata;


@ All jumps together @
jumps = zeros(1,2); jupdate = zeros(1,2);
i = 2;
j = 0;
do until i > rows(rdata);
  if (rdata[i,10] <= 1) AND (rdata[i,3] .eq rdata[i-1,3]);			@ if offer # is 1 and environment # for this trial = env # for previous trial @
    if j<=0;
      jumps[1,1] = rdata[i,13] - rdata[i-1,13];
      jumps[1,2] = rdata[i,1];							@ adding an ID @
      j = j + 1;
      else;
      jupdate = (rdata[i,13] - rdata[i-1,13]) ~ rdata[i,1];
      jumps = jumps | jupdate;
    endif;
    else; ;
  endif;
  i = i + 1;
endo;

@ Start new bootstrap code, also get medians and sample sizes @
n = rows(jumps);




@================================= Declines (first-last) ========================================================@
@ Wait, Cost @
load rdata[1517,17] = c:\schotter\nowaitco.txt;

@ 6/6/07 First calculate the mean etc. of the first to last decline *including* the zeros/people whose first res w worked @
Firstlast_wc = zeros(570,2);
FLindex_wc = zeros(570,2);
FLenvtrl = zeros(570,2);	@ hold env & trial nos @


i = 1; j = 0;
do until i > 1516;
  if rdata[i,10] <= 1;		@ so it's a first offer in the trial @
    j = j + 1;			@ j keeps track of # of environment/trials using each time the offer # hits 1 @
    Firstlast_wc[j,1] = rdata[i,13];	@ Wres for 1st offer in trial @
    FLindex_wc[j,1] = rdata[i,1];	@ ID # @
    FLenvtrl[j,1:2] = rdata[i,3:4];		@ environment # ~ trial # @
    else;
  endif;
  if rdata[i+1,10] <= 1;			@ so this is the last offer, may also be the first @
    Firstlast_wc[j,2] = rdata[i,13];
    FLindex_wc[j,2] = rdata[i,1];
    else; ;
  endif;
  i = i + 1;
endo;

Firstlast_wc[570,2] = rdata[1517,13];
FLindex_wc[570,2] = rdata[1517,1];
FLenvtrl[570,1:2] = 3 ~ 5;



@print "Firstlast_wc"; print firstlast_wc; print "FLindex_wc"; print flindex_wc;@
FL = Firstlast_wc ~ FLindex_wc ~ FLenvtrl;
FL = delif(FL, FL[.,6] .<= 1);				@ applying same sample selection criteria as for recoveries, no first trials since they have no recoveries @
FL_wc = FL;

FLD_wc = FL_wc[.,1] - FL_wc[.,2];			@ 6/6/07 It should be FL_wc[.,1] - FL_wc[.,2], not sure what went wrong here, was 3. @

@print "# of trials of 570 in Wait, Cost in which at least 2 offers"; print (rows(FL_wc));@


@============================== Bootstrap ON INDIVIDUALS ====================================================================@
n = 38;		@ # subjects, was # of observations in base sample @
k = 1000;				@ # of bootstrap iterations, start small @
z = rows(jumps); print "Z"; print z;	@ # of recoveries, should always = 38*12, should be 456 as is # declines here @
jbootID = zeros( k,n );
dbootID = zeros( k,n );
jbootspl = 0;
dbootspl = 0;
draw1 = zeros(n,1);
bootvec = zeros(z,1);
bootmean = zeros(k,1);

boot = 1;
do until boot > k;
  draw1 = rndu(n,1) * (n-1);
  jbootID[boot,.] = (round( draw1 ) + 1)';
  boot = boot + 1;
endo;

boot = 1;
do until boot > k;
  draw1 = rndu(n,1) * (n-1);
  dbootID[boot,.] = (round( draw1 ) + 1)';
  boot = boot + 1;
endo;

@ Use bootstrap ID matrix to put recovery "jumps" entries for bootstrap draws into each entry of jbootspl matrix @
r = 1;	@rows@ c = 1; ID = 0; dbsno=0; jbsno=0; minjd=0; @holds # rows of bootstrapped sample, should always come out same here@
do until r > k;
  jbootspl = 0; dbootspl = 0;
  c = 1;	@ cols @
  do until c > n;
    ID = jbootID[r,c];
    @ now deal with drawing all individual entries @
    j = 1;
    do until j > z;
      if jumps[j,2] .eq ID;
        jbootspl = jbootspl | jumps[j,1];
        else; ;
      endif;
      j = j + 1;
    endo;
    c = c + 1;
  endo;
  c = 1;	@ cols @
  do until c > n;
    ID = dbootID[r,c];
    @ now deal with drawing all individual entries @
    j = 1;
    do until j > z;
      if FL_wc[j,3] .eq ID;
        dbootspl = dbootspl | FLD_wc[j,1];
        else; ;
      endif;
      j = j + 1;
    endo;
    c = c + 1;
  endo;
  jbsno = rows(jbootspl);
  dbsno = rows(dbootspl);
  minjd = minc( jbsno | dbsno );
  jbootspl = jbootspl[1:minjd,1];
  dbootspl = dbootspl[1:minjd,1];
  bootvec = dbootspl - jbootspl;
  bootmean[r,1] = meanc(bootvec);
  r = r + 1;
endo;

@print "WC jumps rows"; print rows(jumps); print "FLD_wc rows"; print rows(FLD_wc);@

@ Note first-last's and jumps should have the same # of entries. Code as if do and watch for errors.@

@ Make 95% CI on mean difference by sorting and cutting the mean vector @
@bootmean = bootmean';@  @so kx1@
bootmean = sortc(bootmean,1);
upCI = .975*k;
upCI = floor(upCI);
loCI = .025*k;
loCI = floor(loCI);
upperCI = bootmean[upCI];
lowerCI = bootmean[loCI];

output file = c:\schotter\aer\jupbstr2.out;
Print "Bootstrapped 95% CI on No Wait, Cost Decline - Recovery Mean, resampling individuals"; print (lowerCI ~ upperCI);
output off;
@============================== End Bootstrap ====================================================================@



@===================================================================================================================@
@ Wait, no cost @
load rdata[1334,17] = c:\schotter\waitnoco.txt;
rdata = zeros(1,17) | rdata;


@================================ Recoveries (jump ups) ===========================================================@
@ All jumps together @
jumps = zeros(1,2); jupdate = zeros(1,2);
i = 2;
j = 0;
do until i > rows(rdata);
  if (rdata[i,10] <= 1) AND (rdata[i,3] .eq rdata[i-1,3]);			@ if offer # is 1 and environment # for this trial = env # for previous trial @
    if j<=0;
      jumps[1,1] = rdata[i,13] - rdata[i-1,13];
      jumps[1,2] = rdata[i,1];							@ adding an ID @
      j = j + 1;
      else;
      jupdate = (rdata[i,13] - rdata[i-1,13]) ~ rdata[i,1];
      jumps = jumps | jupdate;
    endif;
    else; ;
  endif;
  i = i + 1;
endo;

@ Start new bootstrap code, also get medians and sample sizes @
n = rows(jumps);




@================================= Declines (first-last) ========================================================@
@ Wait, Cost @
load rdata[1334,17] = c:\schotter\waitnoco.txt;

@ 6/6/07 First calculate the mean etc. of the first to last decline *including* the zeros/people whose first res w worked @
Firstlast_wc = zeros(570,2);
FLindex_wc = zeros(570,2);
FLenvtrl = zeros(570,2);	@ hold env & trial nos @


i = 1; j = 0;
do until i > 1333;
  if rdata[i,10] <= 1;		@ so it's a first offer in the trial @
    j = j + 1;			@ j keeps track of # of environment/trials using each time the offer # hits 1 @
    Firstlast_wc[j,1] = rdata[i,13];	@ Wres for 1st offer in trial @
    FLindex_wc[j,1] = rdata[i,1];	@ ID # @
    FLenvtrl[j,1:2] = rdata[i,3:4];		@ environment # ~ trial # @
    else;
  endif;
  if rdata[i+1,10] <= 1;			@ so this is the last offer, may also be the first @
    Firstlast_wc[j,2] = rdata[i,13];
    FLindex_wc[j,2] = rdata[i,1];
    else; ;
  endif;
  i = i + 1;
endo;

Firstlast_wc[570,2] = rdata[1334,13];
FLindex_wc[570,2] = rdata[1334,1];
FLenvtrl[570,1:2] = 3 ~ 5;



@print "Firstlast_wc"; print firstlast_wc; print "FLindex_wc"; print flindex_wc;@
FL = Firstlast_wc ~ FLindex_wc ~ FLenvtrl;
FL = delif(FL, FL[.,6] .<= 1);				@ applying same sample selection criteria as for recoveries, no first trials since they have no recoveries @
FL_wc = FL;

FLD_wc = FL_wc[.,1] - FL_wc[.,2];			@ 6/6/07 It should be FL_wc[.,1] - FL_wc[.,2], not sure what went wrong here, was 3. @

@print "# of trials of 570 in Wait, Cost in which at least 2 offers"; print (rows(FL_wc));@


@============================== Bootstrap ON INDIVIDUALS ====================================================================@
n = 38;		@ # subjects, was # of observations in base sample @
k = 1000;				@ # of bootstrap iterations, start small @
z = rows(jumps); print "Z"; print z;	@ # of recoveries, should always = 38*12, should be 456 as is # declines here @
jbootID = zeros( k,n );
dbootID = zeros( k,n );
jbootspl = 0;
dbootspl = 0;
draw1 = zeros(n,1);
bootvec = zeros(z,1);
bootmean = zeros(k,1);

boot = 1;
do until boot > k;
  draw1 = rndu(n,1) * (n-1);
  jbootID[boot,.] = (round( draw1 ) + 1)';
  boot = boot + 1;
endo;

boot = 1;
do until boot > k;
  draw1 = rndu(n,1) * (n-1);
  dbootID[boot,.] = (round( draw1 ) + 1)';
  boot = boot + 1;
endo;

@ Use bootstrap ID matrix to put recovery "jumps" entries for bootstrap draws into each entry of jbootspl matrix @
r = 1;	@rows@ c = 1; ID = 0; dbsno=0; jbsno=0; minjd=0; @holds # rows of bootstrapped sample, should always come out same here@
do until r > k;
  jbootspl = 0; dbootspl = 0;
  c = 1;	@ cols @
  do until c > n;
    ID = jbootID[r,c];
    @ now deal with drawing all individual entries @
    j = 1;
    do until j > z;
      if jumps[j,2] .eq ID;
        jbootspl = jbootspl | jumps[j,1];
        else; ;
      endif;
      j = j + 1;
    endo;
    c = c + 1;
  endo;
  c = 1;	@ cols @
  do until c > n;
    ID = dbootID[r,c];
    @ now deal with drawing all individual entries @
    j = 1;
    do until j > z;
      if FL_wc[j,3] .eq ID;
        dbootspl = dbootspl | FLD_wc[j,1];
        else; ;
      endif;
      j = j + 1;
    endo;
    c = c + 1;
  endo;
  jbsno = rows(jbootspl);
  dbsno = rows(dbootspl);
  minjd = minc( jbsno | dbsno );
  jbootspl = jbootspl[1:minjd,1];
  dbootspl = dbootspl[1:minjd,1];
  bootvec = dbootspl - jbootspl;
  bootmean[r,1] = meanc(bootvec);
  r = r + 1;
endo;

print "WC jumps rows"; print rows(jumps); print "FLD_wc rows"; print rows(FLD_wc);

@ Note first-last's and jumps should have the same # of entries. Code as if do and watch for errors.@

@ Make 95% CI on mean difference by sorting and cutting the mean vector @
@bootmean = bootmean';@  @so kx1@
bootmean = sortc(bootmean,1);
upCI = .975*k;
upCI = floor(upCI);
loCI = .025*k;
loCI = floor(loCI);
upperCI = bootmean[upCI];
lowerCI = bootmean[loCI];

output file = c:\schotter\aer\jupbstr2.out;
Print "Bootstrapped 95% CI on Wait, No Cost Decline - Recovery Mean, resampling individuals"; print (lowerCI ~ upperCI);
output off;

@============================== End Bootstrap ====================================================================@


@output file = c:\schotter\aer\jupsbstr.out off;@
end;